#include <pspkernel.h>
#include <pspdebug.h>
#include <pspctrl.h>
#include <stdlib.h>
#include <string.h>
#include "USB.H"

PSP_MODULE_INFO("GAMEPAD", 0x1000, 1, 1);

int done = 0;

int exit_callback(int arg1, int arg2, void *common)
{
	done = 1;
	return 0;
}

int CallbackThread(SceSize args, void *argp)
{
	int cbid;

	cbid = sceKernelCreateCallback("Exit Callback", exit_callback, NULL);
	sceKernelRegisterExitCallback(cbid);
	sceKernelSleepThreadCB();

	return 0;
}

int SetupCallbacks(void)
{
	int thid = 0;

	thid = sceKernelCreateThread("update_thread", CallbackThread,
				     0x11, 0xFA0, 0, 0);
	if(thid >= 0)
	{
		sceKernelStartThread(thid, 0, 0);
	}

	return thid;
}

#define printf	pspDebugScreenPrintf

int main(void)
{

	SceCtrlData pad;
    pspDebugScreenInit();
    SetupCallbacks();
	
	UsbbdRegister();

	sceCtrlSetSamplingCycle(0);
	sceCtrlSetSamplingMode(PSP_CTRL_MODE_ANALOG);

	while(!done){

    		sceCtrlReadBufferPositive(&pad, 1); 
		if (pad.Buttons != 0){

			if (pad.Buttons & PSP_CTRL_CIRCLE){
				UsbStart();
				while (pad.Buttons & PSP_CTRL_CIRCLE) sceCtrlReadBufferPositive(&pad, 1);
			} 
			if (pad.Buttons & PSP_CTRL_CROSS){
				UsbStop();
				while (pad.Buttons & PSP_CTRL_CROSS) sceCtrlReadBufferPositive(&pad, 1);
			} 
    
		}
	}
	UsbbdUnregister();
	sceKernelExitGame();
	return 0;
}
